/*******************************************************************************
 * @author    Patricie Benešová
 * @version   1.00.000
 */
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Generické funkční rozhraní
 */
interface GenerickeFunkcniRozhrani<T,U>{
    U sloucit(List<T> seznam);
}

public class SeznamPrevod {

   private List<Integer> seznamCisel = new ArrayList<>();
   private List<String> seznamSlov = new ArrayList<>();
   

    public SeznamPrevod() {
        seznamCisel.add(1);
        seznamCisel.add(5);
        seznamCisel.add(6);
        seznamCisel.add(3);
        
        seznamSlov.add("propiska");
        seznamSlov.add("pastelka");
        seznamSlov.add("blok");
        seznamSlov.add("laptop");
        
          
    }

    /**
     * Getter pro získání seznamu čísel
     */
    public List<Integer> getSeznamCisel() {
        return seznamCisel;
    }

    /**
     * Getter pro získání seznamu slov
     */
    public List<String> getSeznamSlov() {
        return seznamSlov;
    }

    
    public static void main(String[] args) {
        SeznamPrevod ins = new SeznamPrevod();
        
        GenerickeFunkcniRozhrani<Integer,Long> soucet = (a) -> {
            long vysledek = 0;
            for(int i = 0; i< a.size();i++){
                vysledek += a.get(i);
            }
            return vysledek;
        };
        
        GenerickeFunkcniRozhrani<String,String> retezec = (b) -> {
          String vysledek = "";
          for(int i = 0; i < b.size();i++){
              vysledek += b.get(i) + " ";
          }
          return vysledek;
        };
        
        long soucetSeznamu = soucet.sloucit(ins.getSeznamCisel());
        String retezecZeSeznamu = retezec.sloucit(ins.getSeznamSlov());
        
        System.out.println(soucetSeznamu);
        System.out.println(retezecZeSeznamu);
    }
    
    
    
}

